<template>
  <div>
    <b-form @submit.prevent="onSubmit" @reset.prevent="onReset" v-if="show">
      <b-form-group
        id="input-group-1"
        label="Email address:"
        label-for="input-1"
        description="We'll never share your email with anyone else."
      >
        <b-form-input
          id="input-1"
          type="email"
          placeholder="Enter email"
          v-model="form.email"
          required
        >
        </b-form-input>
      </b-form-group>
      <b-form-group id="input-group-2" label="Your Name:" label-for="input-2">
        <b-form-input
          id="input-2"
          placeholder="Enter name"
          v-model="form.name"
          required
        >
        </b-form-input>
      </b-form-group>

      <b-form-group id="input-group-3" label="Food:" label-for="input-3">
        <b-form-select
          id="input-3"
          v-model="form.foods"
          :options="foods"
          required
        >
        </b-form-select>
      </b-form-group>

      <b-form-group id="input-group-4" v-slot="{ ariaDescribeby }">
        <b-form-checkbox-group
          id="checkboxes-4"
          v-model="form.checked"
          :aria-describedby="ariaDescribeby"
        >
          <b-form-checkbox value="me">Check me out</b-form-checkbox>
          <b-form-checkbox value="that">Check that out</b-form-checkbox>
        </b-form-checkbox-group>
      </b-form-group>
      <b-button type="submit" variant="primary">Submit</b-button>
      <b-button type="reset" variant="danger">Reset</b-button>
      <b-card class="mt-3" header="Form Data Result">
        <pre class="m-0">
              {{ form }}
          </pre
        >
      </b-card>
    </b-form>
  </div>
</template>
<script>
export default {
  data () {
    return {
      form: {
        email: '',
        name: '',
        food: '',
        checked: []
      },
      foods: [
        { text: 'Select One', value: null },
        'Carrots',
        'Beans',
        'Tomatoes',
        'Corn'
      ],
      show: true
    }
  },
  methods: {
    onSubmit (event) {
      alert(JSON.stringify(this.form))
    },
    onReset (event) {
      this.form.email = ''
      this.form.name = ''
      this.form.food = []
      this.form.checked = null
      this.show = false
      this.$nextTick(() => {
        this.show = true
      })
    }
  }
}
</script>
<style></style>
